/* An interface is a type, just as a class, even an abstract class,
   is a type. An object is of the type of its class (and superclasses)
   as well as of the type of all the interfaces its class implements.*/
interface ITaxable
{
   double calculateTax(int price);
}
abstract class AbstractInventory {}
class Inventory extends AbstractInventory implements ITaxable
{
     public double calculateTax(int price)
     {
         return price * .0875;
     }
}
class SpecialOrder implements ITaxable
{
     public double calculateTax(int price)
     {
         return price * .0875;
     }
}
public class InterfaceAsTypeDemo
{
   public static void main(String[] args)
   {
      // array of the interface type to hold 3 objects
      ITaxable[] myInterfaceArray = new ITaxable[3];
      // objects of a type that implements an interface
      Inventory myInventory0 = new Inventory();
      Inventory myInventory1 = new Inventory();
      SpecialOrder mySpecialOrder2 = new SpecialOrder();
      // populate the interface type array
      // with objects of ANY type that implements
      // the array
      for(int i = 0; i < myInterfaceArray.length;  i++)
      {
         myInterfaceArray[0] = myInventory0;
         myInterfaceArray[1] = myInventory1;
         myInterfaceArray[2] = mySpecialOrder2;
         System.out.println(myInterfaceArray[i].getClass().toString());
         if(myInterfaceArray[i] instanceof ITaxable)  System.out.println(myInterfaceArray[i].toString() + " is an instance of ITaxable");
         if(myInterfaceArray[i] instanceof Object)  System.out.println(myInterfaceArray[i].toString() + " is an instance of Object");
         if(myInterfaceArray[i] instanceof AbstractInventory)  System.out.println(myInterfaceArray[i].toString() + " is an instance of AbstractInventory");
      }
   }
}